Index: lib/spatial/mapbuilder/lib/util/Util.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/Util.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/util/Util.js	(revision 4307)
@@ -2,7 +2,7 @@
 License:      LGPL as per: http://www.gnu.org/copyleft/lesser.html
 Dependancies: Sarissa
 
-$Id$
+$Id: Util.js 3961 2008-04-01 12:45:02Z ahocevar $
 */
 
 // some basic browser detection
@@ -16,18 +16,53 @@
 @author Cameron Shorter - Cameron AT Shorter.net
 */
 function XslProcessor(xslUrl,docNSUri) {
+  // override Sarissa configurations to prefer MSXML3, because
+  // MSXML6 does not work well with IE6SP2
+  if (!MB_IS_MOZ) {
+    _SARISSA_DOM_PROGID = Sarissa.pickRecentProgID(["Msxml2.DOMDocument.3.0", "Msxml2.DOMDocument.6.0"], [["SELECT_NODES", 2],["TRANSFORM_NODE", 2]]);
+    _SARISSA_XMLHTTP_PROGID = Sarissa.pickRecentProgID(["Msxml2.XMLHTTP.3.0", "MSXML2.XMLHTTP.6.0"], [["XMLHTTP", 4]]);
+    _SARISSA_THREADEDDOM_PROGID = Sarissa.pickRecentProgID(["Msxml2.FreeThreadedDOMDocument.3.0", "MSXML2.FreeThreadedDOMDocument.6.0"]);
+    _SARISSA_XSLTEMPLATE_PROGID = Sarissa.pickRecentProgID(["Msxml2.XSLTemplate.3.0", "MSXML2.XSLTemplate.6.0"], [["XSLTPROC", 2]]);
+  }
   // get the stylesheet document
   this.xslUrl=xslUrl;
   this.xslDom = Sarissa.getDomDocument();
   this.xslDom.async = false;
-  this.xslDom.validateOnParse=false;  //IE6 SP2 parsing bug
-  this.xslDom.load(xslUrl);
-  if ( this.xslDom.parseError < 0 )
-    alert("error loading XSL stylesheet: " + xslUrl);
+  // fix some issues in IE
+  if (!MB_IS_MOZ) {
+    try {
+      // IE6 SP2 parsing bug
+      this.xslDom.validateOnParse=false;
+      // Prevent "Access denied" with external documents
+      this.xslDom.setProperty("AllowDocumentFunction", true);
+      this.xslDom.resolveExternals = true;
+    }
+    catch (e) {
+      // do nothing here, we won't get far anyway.
+    }
+  }
+  if(typeof(inlineXSL)!="undefined") {
+    xmlString = inlineXSL[_1];
+    xmlString = xmlString.replace(/DOUBLE_QUOTE/g,"\"");
+    this.xslDom = (new DOMParser()).parseFromString(xmlString, "text/xml");
+  }
+  else {
+    if(_SARISSA_IS_SAFARI){
+        var xmlhttp = new XMLHttpRequest();
+        xmlhttp.open("GET", xslUrl, false);
+        xmlhttp.send(null);
+        this.xslDom = xmlhttp.responseXML;
+    }else
+    {
+      this.xslDom.load(xslUrl);
+    }
+  }
+  if ( Sarissa.getParseErrorText(this.xslDom) != Sarissa.PARSED_OK )
+    alert(mbGetMessage("errorLoadingStylesheet", xslUrl));
 
   this.processor = new XSLTProcessor();
   this.processor.importStylesheet(this.xslDom);
-
+  
   this.docNSUri = docNSUri;
 
   /**
@@ -38,13 +73,21 @@
   this.transformNodeToString = function(xmlNode) {
     try {
       // transform and build a web page with result
+      //MAP-427 Quick hack to transform an XMLElement to XMLDocument in IE
+     
+      if (_SARISSA_IS_IE){
+	      var str = (new XMLSerializer()).serializeToString(xmlNode);
+	      var xmlNode = (new DOMParser()).parseFromString(str, "text/xml");
+	  }
       var newDoc = this.transformNodeToObject(xmlNode);
-      var s = Sarissa.serialize(newDoc);
-      return Sarissa.unescape(s);
+      var s = (new XMLSerializer()).serializeToString(newDoc);
+      if(_SARISSA_IS_OPERA)
+      	s =  s.replace(/.*\?\>/,"");//hack for opera to delete <?xml ... ?>
+      return s;
     } catch(e){
-      alert("Exception transforming doc with XSL: " + this.xslUrl);
-      alert("XSL="+Sarissa.serialize(this.xslDom));
-      alert("XML="+Sarissa.serialize(xmlNode));
+      alert(mbGetMessage("exceptionTransformingDoc", this.xslUrl));
+      alert("XSL="+(new XMLSerializer()).serializeToString(this.xslDom));
+      alert("XML="+(new XMLSerializer()).serializeToString(xmlNode));
     }
   }
 
@@ -54,7 +97,14 @@
    * @return a DOM document object
    */
   this.transformNodeToObject=function(xmlNode) {
-    var newFragment = this.processor.transformToDocument(xmlNode);
+    if(_SARISSA_IS_SAFARI){
+      var oResult = new DOMParser().parseFromString("<xsltresult></xsltresult>", "text/xml");
+      var newFragment = this.processor.transformToFragment(xmlNode, oResult);
+      var str = (new XMLSerializer()).serializeToString(newFragment);
+      str.replace(/\s/g,"");
+    }else{
+       var newFragment = this.processor.transformToDocument(xmlNode);
+    }
     return newFragment;
   }
 
@@ -76,7 +126,7 @@
  */
 function postLoad(sUri, docToSend, contentType ) {
    var xmlHttp = new XMLHttpRequest();
-   if ( sUri.indexOf("http://")==0 ) {
+   if ( sUri.indexOf("http://")==0 || sUri.indexOf("https://")==0 ) {
      xmlHttp.open("POST", config.proxyUrl, false);
      xmlHttp.setRequestHeader("serverUrl",sUri);//escape(sUri).replace(/\+/g, '%2C').replace(/\"/g,'%22').replace(/\'/g, '%27'));
    } else {
@@ -96,17 +146,62 @@
    }
 */
    if (xmlHttp.status >= 400) {   //http errors status start at 400
-      alert("error loading document: " + sUri + " - " + xmlHttp.statusText + "-" + xmlHttp.responseText );
+      alert(mbGetMessage("errorLoadingDocument", sUri, xmlHttp.statusText, xmlHttp.responseText));
       var outDoc = Sarissa.getDomDocument();
       outDoc.parseError = -1;
       return outDoc;
    } else {
      //alert(xmlHttp.getResponseHeader("Content-Type"));
-     if ( null==xmlHttp.responseXML ) alert( "null XML response:" + xmlHttp.responseText );
+     if ( null==xmlHttp.responseXML ) alert(mbGetMessage("nullXmlResponse", xmlHttp.responseText));
      return xmlHttp.responseXML;
    }
 }
 
+
+/**
+ * A more flexible interface for loading docs that allows POST et GET param for save model
+ */
+
+function postGetLoad(sUri, docToSend, contentType , dir, fileName) {
+
+   var xmlHttp = new XMLHttpRequest();
+   var appendChar = sUri.indexOf("?") == -1 ? "?" : "&";
+   if(dir && fileName)
+       	sUri=sUri+appendChar+"dir="+dir+"&fileName="+fileName;
+   else if(dir)
+   		sUri=sUri+appendChar+"dir="+dir;
+   else if(fileName)
+   		sUri=sUri+appendChar+"fileName="+fileName;
+   		
+   if ( sUri.indexOf("http://")==0 || sUri.indexOf("https://")==0 )
+   {
+       xmlHttp.open("POST", config.proxyUrl, false);       
+       xmlHttp.setRequestHeader("serverUrl",sUri);
+   }
+   else
+   {
+       xmlHttp.open("POST", sUri, false);
+   }
+   xmlHttp.setRequestHeader("content-type","text/xml");
+   if (contentType) xmlHttp.setRequestHeader("content-type",contentType);
+   xmlHttp.send( docToSend );
+
+   if (xmlHttp.status >= 400)
+   {   //http errors status start at 400
+        alert(mbGetMessage("errorLoadingDocument", sUri, xmlHttp.statusText, xmlHttp.responseText));
+        var outDoc = Sarissa.getDomDocument();
+        outDoc.parseError = -1;
+        return outDoc;
+   }
+   else
+   {
+       if ( null==xmlHttp.responseXML ) alert(mbGetMessage("nullXmlResponse", xmlHttp.responseText));
+       return xmlHttp.responseXML;
+   }
+}
+
+
+
   /**
    * If URL is local, then return URL unchanged,
    * else return URL of http://proxy?url=URL , or null if proxy not defined.
@@ -114,11 +209,11 @@
    * @return Url of the proxy and service in the form http://host/proxy?url=service
    */
 function getProxyPlusUrl(url) {
-  if ( url.indexOf("http://")==0 ) {
+  if ( url.indexOf("http://")==0 || url.indexOf("https://")==0 ) {
     if ( config.proxyUrl ) {
       url=config.proxyUrl+"?url="+escape(url).replace(/\+/g, '%2C').replace(/\"/g,'%22').replace(/\'/g, '%27');
     } else {
-      alert("unable to load external document:"+url+"  Set the proxyUrl property in config.");
+      alert(mbGetMessage("unableToLoadDoc", url));
       url=null;
     }
   }
@@ -126,20 +221,15 @@
 }
 
   /**
-   * Browser independant version of createElementNS() because creating elements
-   * with namespaces other than the defalut namespace isn't dupported in IE,
-   * or at least I can't figure out how to do it.  
-   * Caution: In IE the new element doesn't appear to a namespace!!
+   * Browser independant version of createElementNS()
    * @param doc the owner document for the new element
-   * @param name the name for the new element
+   * @param name for the new element
    * @param ns the URL for the namespace (without a prefix)
    * @return element in the document with the specified namespace
    */
 function createElementWithNS(doc,name,nsUri) {
   if (_SARISSA_IS_IE) {
-    var newElement = doc.createElement(name);
-    //newElement.namespaceURI = nsUri;  //can't do this for some reason?
-    return newElement;
+    return doc.createNode(1, name, nsUri);
   } else {
     return doc.createElementNS(nsUri,name);
   }
@@ -173,7 +263,7 @@
   }
   var isoDate = new Date();
   isoDate.setFullYear(parseInt(parts[1],10));
-  isoDate.setMonth(parseInt(parts[2]-1,10));
+  isoDate.setMonth(parseInt(parts[2],10)-1,parseInt(parts[3],10));
   isoDate.setDate(parseInt(parts[3],10));
   isoDate.setHours(parseInt(parts[4],10));
   isoDate.setMinutes(parseInt(parts[5],10));
@@ -186,12 +276,12 @@
 function getISODate(isoDate) {
   var res = isoDate.res?isoDate.res:6;
   var dateStr = "";
-  dateStr += res>1?isoDate.getFullYear():"";
-  dateStr += res>2?"-"+leadingZeros(isoDate.getMonth()+1,2):"";
-  dateStr += res>3?"-"+leadingZeros(isoDate.getDate(),2):"";
-  dateStr += res>4?"T"+leadingZeros(isoDate.getHours(),2):"";
-  dateStr += res>5?":"+leadingZeros(isoDate.getMinutes(),2):"";
-  dateStr += res>6?":"+leadingZeros(isoDate.getSeconds(),2):"";
+  dateStr += res>=1?isoDate.getFullYear():"";
+  dateStr += res>=2?"-"+leadingZeros(isoDate.getMonth()+1,2):"";
+  dateStr += res>=3?"-"+leadingZeros(isoDate.getDate(),2):"";
+  dateStr += res>=4?"T"+leadingZeros(isoDate.getHours(),2):"";
+  dateStr += res>=5?":"+leadingZeros(isoDate.getMinutes(),2):"";
+  dateStr += res>=6?":"+leadingZeros(isoDate.getSeconds(),2):"";
   return dateStr;
 }
 
@@ -208,14 +298,29 @@
 // thanks to Caroklyn Cole for this fix.  For an explanation see:
 // http://homepage.ntlworld.com/bobosola. Updated 02-March-2004
 // modified to the images as visible after this has been called.
-function fixPNG(myImage,myId) {
+// PL-BRGM
+// Add oldImage in parameter
+function fixPNG(myImage,myId,oldImage) {
   if (_SARISSA_IS_IE) {
+    // PL - BRGM
+    //opacity of the image
+    if(oldImage) {
+      var valIEOpacity= oldImage.style.filter.substring(oldImage.style.filter.indexOf('opacity=',0)+8,oldImage.style.filter.lastIndexOf(')',0));
+      if(oldImage.style.filter.indexOf('opacity=',0) ==-1){
+        valIEOpacity = null;
+      }
+       var _opacity= (valIEOpacity)?valIEOpacity/100:-1;
+     }
+  // END
     var imgID = "id='" + myId + "' ";
     var imgClass = (myImage.className) ? "class='" + myImage.className + "' " : ""
     var imgTitle = (myImage.title) ? "title='" + myImage.title + "' " : "title='" + myImage.alt + "' "
-    var imgStyle = "display:inline-block;" + myImage.style.cssText 
+    var imgStyle = "display:inline-block;" + myImage.style.cssText
     var strNewHTML = "<span " + imgID + imgClass + imgTitle
+
     strNewHTML += " style=\"" + "width:" + myImage.width + "px; height:" + myImage.height + "px;" + imgStyle + ";"
+    // store the opacity in the style even not used by IE
+    if (_opacity!=-1) strNewHTML += "opacity=" + _opacity + ";" ;
     // Escape some chars (don't use encode() that would escape %xx previously used in XSL)
     var src = myImage.src;
     src = src.replace(/\(/g,'%28');
@@ -224,7 +329,13 @@
     // AlphaImageLoader converts '%23' in src to '#' and cuts URL on '#'
     src = src.replace(/%23/g,'%2523');
     strNewHTML += "filter:progid:DXImageTransform.Microsoft.AlphaImageLoader";
-    strNewHTML += "(src=\'" + src + "\', sizingMethod='scale'); \"></span>" ;
+    strNewHTML += "(src=\'" + src + "\', sizingMethod='scale')";
+
+    // PL - BRGM
+    // add the opacity
+    if (oldImage && _opacity!=-1) strNewHTML +=  " alpha(opacity=" + (_opacity * 100) + ")";
+    strNewHTML +="; \"></span>" ;
+  // END PL - BRGM
     //myImage.outerHTML = strNewHTML;
     //alert(strNewHTML);
     return strNewHTML;
@@ -312,7 +423,7 @@
 }
 
 /**
- * parse comma-separated name=value argument pairs from the query string of the URL; the function stores name=value pairs in properties of an object and returns that object. 
+ * parse comma-separated name=value argument pairs from the query string of the URL; the function stores name=value pairs in properties of an object and returns that object.
  * @return args Array of arguments passed to page, in form args[argname] = value.
  */
 function getArgs(){
@@ -486,3 +597,258 @@
   if (obj!=null) obj.handleEvent(evt);
 }
 
+/**
+ * Show a message if the debug property of the object has been set.
+ * @param object  the object that possibly has the debug property set
+ * @param message the message to show
+ */
+function mbDebugMessage(object, message)
+{
+  if (object && object.debug) {
+    alert(message);
+  }
+}
+
+/**
+ * Get a message from the <code>widgetText</code> file and format it if extra
+ * arguments are passed.
+ * @param messageKey       the message key within the message node
+ * @param varArgs          optional extra parameters for formatting the message
+ * @return                 <code>"NoMsgsFound"</code> if the <code>widgetText</code> file is not found,<br/>
+ *                         the <code>messageKey</code> if the message key was not found within the message node,<br/>
+ *                         the (formatted) message if it was found
+ */
+function mbGetMessage(messageKey)
+{
+  var message = "NoMsgsFound";
+  if (config.widgetText) {
+    var msgKeyXpath = "/mb:WidgetText/mb:messages/mb:" + messageKey;
+    var msgKeyNodes = config.widgetText.selectNodes(msgKeyXpath);
+    if (!msgKeyNodes || msgKeyNodes.length == 0) {
+      // Message not found, fall back to message key
+      message = messageKey;
+    }
+    else {
+      // Message found; pick last one so user can override messages
+      message = getNodeValue(msgKeyNodes.item(msgKeyNodes.length-1));
+      if (arguments[mbGetMessage.length]) {
+        // Extra arguments, format message
+        var varArgs = [].slice.call(arguments, mbGetMessage.length);
+        varArgs.unshift(message);
+        message = mbFormatMessage.apply(this, varArgs);
+      }
+    }
+  }
+  return message;
+}
+
+/**
+ * Format a message with the extra arguments. <br/>
+ * E.g. if called as: <code>mbFormatMessage("{1} is {0} {2}, {1}", "a good", "this", "test")</code><br/>
+ * the formatted message returned is: <code>"this is a good test, this"</code>
+ * @param messageFormat the message format string
+ * @param varArgs       optional extra parameters for formatting the message
+ * @return              the formatted message
+ */
+function mbFormatMessage(messageFormat)
+{
+  var message = messageFormat;
+  var varArgs = [].slice.call(arguments, mbFormatMessage.length);
+  for (var i=0; i<varArgs.length; i++) {
+    var parm = new RegExp("\\{" + i + "\\}", "g");
+    message = message.replace(parm, varArgs[i]);
+  }
+  return message;
+}
+
+/**
+ * extract a style from a SLD node of an XML doc and return
+ * it as url parameter for a WMS request
+ * @param node XML node containing the styled layer descriptor
+ * @return WMS-compliant SLD URL parameters as array
+ */
+function sld2UrlParam(node) {
+  var params=new Array();
+  if (node) {
+    var sld = node.selectSingleNode("wmc:SLD");
+    var name = node.selectSingleNode("wmc:Name");
+    if(sld) {
+      if(sld.selectSingleNode("wmc:OnlineResource")) {	
+        params.sld=sld.selectSingleNode("wmc:OnlineResource").getAttribute("xlink:href");
+      } else if(sld.selectSingleNode("wmc:FeatureTypeStyle")) {
+        params.sld=(new XMLSerializer()).serializeToString(sld.selectSingleNode("wmc:FeatureTypeStyle"));
+      } else if(sld.selectSingleNode("wmc:StyledLayerDescriptor")) { 
+        params.sld_body=(new XMLSerializer()).serializeToString(sld.selectSingleNode("wmc:StyledLayerDescriptor"));    		
+      }
+    } else if(name) {
+      params.styles = getNodeValue(name) || "";	
+    }
+  }  
+  return params;
+}
+
+/**
+ * extract a style from a SLD node of an XML doc and return
+ * it as OpenLayers style
+ * @param objRef reference to the map widget that will use the style
+ * @param node XML node containing the styled layer descriptor
+ * @return OpenLayers style object
+ */
+function sld2OlStyle(node) {
+  // OpenLayers SLD parsing
+  if (node) {
+    var ruleNode = node.selectSingleNode("wmc:SLD/sld:FeatureTypeStyle");
+    if (ruleNode) {
+      var sld = new XMLSerializer().serializeToString(ruleNode);
+      var search = /<([^:]*:?)StyledLayerDescriptor/;
+      if (!search.test(sld)) {
+      	sld = sld.replace(/<([^:]*:?)FeatureTypeStyle([^>]*)>(.*)$/,
+            "<$1StyledLayerDescriptor$2><$1NamedLayer><$1Name>sld</$1Name><$1UserStyle><$1FeatureTypeStyle>$3</$1UserStyle></$1NamedLayer></$1StyledLayerDescriptor>");
+      }
+    }
+    var styles = new OpenLayers.Format.SLD().read(sld);
+    if (styles) {
+      return styles.namedLayers["sld"].userStyles[0];
+    }
+  }
+  
+  // fallback to native SLD parsing for older OwsContext docs
+  
+  // sld-conform default style
+  var defaultStyle = {
+            fillColor: "#808080",
+            fillOpacity: 1,
+            strokeColor: "#000000",
+            strokeOpacity: 1,
+            strokeWidth: 1,
+            pointRadius: 6};
+            
+  var style1=OpenLayers.Util.extend(defaultStyle,OpenLayers.Feature.Vector.style["default"]);
+  var value;
+  var styleSet=false;
+
+  if (node) {
+    value=node.selectSingleNode(".//sld:ExternalGraphic/sld:OnlineResource/@xlink:href");
+    if(value){
+      style1.externalGraphic=getNodeValue(value);
+      styleSet=true;
+    }
+    value=node.selectSingleNode(".//sld:Fill/sld:CssParameter[@name='fill']");
+    if(value){
+      style1.fillColor=getNodeValue(value);
+      styleSet=true;
+    }
+    value=node.selectSingleNode(".//sld:Fill/sld:CssParameter[@name='fill-opacity']");
+    if(value){
+      style1.fillOpacity=getNodeValue(value);
+      styleSet=true;
+    } else {
+      // opacity eg. for externalGraphic
+      value=node.selectSingleNode(".//sld:Opacity/sld:Literal");
+      if (value){
+        style1.fillOpacity=getNodeValue(value);
+        styleSet=true;
+      }
+    }
+  
+    value=node.selectSingleNode(".//sld:Stroke/sld:CssParameter[@name='stroke']");
+    if(value){
+      style1.strokeColor=getNodeValue(value);
+      styleSet=true;
+    }
+    
+    value=node.selectSingleNode(".//sld:Stroke/sld:CssParameter[@name='stroke-opacity']");
+    if(value){
+      style1.strokeOpacity=getNodeValue(value);
+      styleSet=true;
+    }
+    
+    value=node.selectSingleNode(".//sld:Stroke/sld:CssParameter[@name='stroke-width']");
+    if(value){
+      style1.strokeWidth=getNodeValue(value);
+      styleSet=true;
+    }
+    
+    value=node.selectSingleNode(".//sld:Size");
+    if(value){
+      style1.pointRadius=getNodeValue(value);
+      styleSet=true;
+    }
+  }
+  
+  if(!styleSet)style1=null;
+  return style1;
+}
+
+/**
+ * Dynamically loads a stylesheet into the html page.
+ * @param cssFileName name of the file to load, relative to config.skinDir
+ */
+function loadCss(cssFileName) {
+  // queue the request if we do not know the skinDir yet
+  if (typeof config == "undefined" || typeof config.skinDir != "string") {
+    if (!mapbuilder.cssToLoad) {
+      mapbuilder.cssToLoad = [];
+    }
+    mapbuilder.cssToLoad.push(cssFileName);
+    return;
+  }
+  
+  var id = cssFileName.match(/[^\/]*$/).toString().replace(/./, '_');
+  if (!document.getElementById(id)) {
+    var cssNode = document.createElement('link');
+    cssNode.setAttribute('id', id);
+    cssNode.setAttribute('rel', 'stylesheet');
+    cssNode.setAttribute('type', 'text/css');
+    cssNode.setAttribute('href', config.skinDir+'/'+cssFileName);
+    document.getElementsByTagName('head')[0].appendChild(cssNode);
+  }
+}
+
+/**
+ * getNodevalue return value of node
+ * it as OpenLayers style
+ * @param node 
+ * @return return node's value
+ */
+function getNodeValue(sResult){
+  if(sResult.nodeType == 1) return sResult.firstChild ? sResult.firstChild.nodeValue : "";
+  if(sResult.nodeType < 5) return sResult.nodeValue;
+  return sResult;
+}
+
+/**
+ * Convenience method that is used to parse dom nodes.
+ * @param domNode node to find the property in
+ * @param propertyName string of the property name (including namespace prefix)
+ * @param defaultValue value to return if property is not found (null by default)
+ * @return the property value
+ */
+Mapbuilder.getProperty = function(domNode, propertyName, defaultValue) {
+  if (typeof defaultValue == "undefined") {
+    defaultValue = null;
+  }
+  var property = domNode.selectSingleNode(propertyName);
+  return property ? getNodeValue(property) : defaultValue;
+}
+
+/**
+ * Convenience method to parse a string or number as a boolean value
+ * @param value string (true/false) or number (1/0)
+ * @return boolean value, default false
+ */
+Mapbuilder.parseBoolean = function(value) {
+  var result = false;
+  if (!value) {
+    result = false;
+  } else if (value == 0) {
+    result = false;
+  } else if (value == 1) {
+      result = true;
+  } else if (value.match(/true/i)) {
+    result = true;
+  } else if (value.match(/false/i)){
+    return false;
+  }
+  return result;
+}
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32738.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32738.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32738.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:32738"] = "+proj=utm +zone=38 +south +ellps=WGS84 +datum=WGS84 +units=m +no_defs ";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102757.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102757.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102757.js	(revision 4307)
@@ -0,0 +1,6 @@
+Proj4js.defs["EPSG:102757"] = "+title=NAD 1983 StatePlane Wyoming West Central FIPS 4903 Feet\
+  +proj=tmerc \
+  +lat_0=40.5 +lon_0=-108.75 \
+  +x_0=600000.0 +y_0=0 +k=0.999938 \
+  +a=6378137.0  +b=6356752.3141403\
+  +to_meter=0.3048006096012192";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG42304.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG42304.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG42304.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:42304"]="+proj=lcc +lat_1=49 +lat_2=77 +lat_0=49 +lon_0=-95 +x_0=0 +y_0=0 +ellps=GRS80 +datum=NAD83 +units=m +no_defs";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32614.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32614.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG32614.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:32614"] = "+title=WGS 84 / UTM zone 14N epsg:32614 +proj=utm +zone=14 +ellps=WGS84 +datum=WGS84 +units=m +no_defs";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31292.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31292.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31292.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31292"] = "+title=MGI (Ferro) / Austria Central Zone EPSG:31292 +proj=tmerc +lat_0=0 +lon_0=31 +k=1.000000 +x_0=0 +y_0=0 +ellps=bessel +pm=ferro +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m +no_defs";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG26912.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG26912.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG26912.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG26912"] = "+title=NAD83 / UTM zone 12N +proj=utm +zone=12 +a=6378137.0 +b=6356752.3141403";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102005.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102005.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG102005.js	(revision 4307)
@@ -0,0 +1,13 @@
+//
+//# USA Contiguous Equidistant Conic
+//<102005> +proj=eqdc +lat_0=0 +lon_0=0 +lat_1=33 +lat_2=45 +x_0=0 +y_0=0 +ellps=GRS80 +datum=NAD83 +units=m 
+
+Proj4js.defs["EPSG:102005"] = "\
+  +title=USA Contiguous Equidistant Conic\
+  +proj=eqdc\
+  +lat_0=0 +lon_0=0 +lat_1=33 +lat_2=45 +x_0=0 +y_0=0   \
+  +lon_0=-90 +x_0=600000.0000000001 +y_0=0 \
+  +ellps=GRS80 +datum=NAD83 +units=m \
+  ";
+
+
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG26986.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG26986.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG26986.js	(revision 4307)
@@ -0,0 +1,14 @@
+//# NAD83 / Massachusetts Mainland, United States (USA) - Massachusetts - SPCS - mainland 
+
+//+proj=lcc +lat_1=42.68333333333333 +lat_2=41.71666666666667 +lat_0=41 +lon_0=-71.5 +x_0=200000 +y_0=750000 +ellps=GRS80 +datum=NAD83 +units=m +no_defs  <>
+
+
+Proj4js.defs["EPSG:26986"]= "\
+  +title=NAD 1983 StatePlane Wyoming West Central FIPS 4903 Feet\
+  +proj=lcc \
+  +lat_1=42.68333333333333 +lat_2=41.71666666666667 +lat_0=41 +lon_0=-71.5 \
+  +x_0=200000 +y_0=750000 \
+  +ellps=GRS80  \
+  +units=m +no_defs \
+";
+
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG42101.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG42101.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG42101.js	(revision 4307)
@@ -0,0 +1,5 @@
+//## WGS84 / LCC Canada
+//<42101> +proj=lcc +ellps=WGS84 +lat_0=0 +lon_0=-95 +lat_1=49 +lat_2=77 +x_0=0 +y_0=-8000000.0 +datum=WGS84 +units=m no_defs <>
+Proj4js.defs["EPSG:42101"]= "+title=WGS84 / LCC Canada EPSG:42101\
+  +proj=lcc +ellps=WGS84 +lat_0=0 +lon_0=-95 +lat_1=49 +lat_2=77 +x_0=0 +y_0=-8000000.0 +datum=WGS84 +units=m\
+ ";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31281.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31281.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31281.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31281"] = "+title=MGI (Ferro) / Austria West Zone EPSG:31281 +proj=tmerc +lat_0=0 +lon_0=28 +k=1.000000 +x_0=0 +y_0=0 +ellps=bessel +pm=ferro +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m +no_defs";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31283.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31283.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31283.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31283"] = "+title=MGI (Ferro) / Austria East Zone EPSG:31283 +proj=tmerc +lat_0=0 +lon_0=34 +k=1.000000 +x_0=0 +y_0=0 +ellps=bessel +pm=ferro +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m +no_defs";
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG22195.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG22195.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG22195.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:22195"]= "+title=Campo Inchauspe / Argentina 5 epsg:22195 +proj=tmerc +lat_0=-90 +lon_0=-60 +k=1.000000 +x_0=5500000 +y_0=0 +ellps=intl +units=m +no_defs";
\ No newline at end of file
Index: lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31287.js
===================================================================
--- lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31287.js	(nonexistent)
+++ lib/spatial/mapbuilder/lib/util/proj4js/defs/EPSG31287.js	(revision 4307)
@@ -0,0 +1 @@
+Proj4js.defs["EPSG:31287"] = "+title=MGI / Austria Lambert EPSG:31287 +proj=lcc +lat_1=49 +lat_2=46 +lat_0=47.5 +lon_0=13.33333333333333 +x_0=400000 +y_0=400000 +ellps=bessel +towgs84=577.326,90.129,463.919,5.137,1.474,5.297,2.4232 +units=m";
